<?php
/**
 * Aggiungi queste funzioni
 * nel file functions.php
 */

// ************
// Add meta box
// ************

function my_related_add_meta_box() {
	add_meta_box(
		"correlati",
		esc_html__( "Articoli correlati", "mytextdomain" ),
		"my_related_render_meta_box_content",
		"post",
		"advanced",
		"high"
	);
}

add_action( "add_meta_boxes", "my_related_add_meta_box" );

// ***************
// Render meta box
// ***************

function my_related_render_meta_box_content( $post ) {

// ***
// Il numero di post correlati desiderato
// ***

	$n = "3";

// ***
// Gli argomenti della query WP_Query
// ***

	$args = array (
		"post_type" => $post->post_type,
		"orderby" => "title",
		"order"	=> "ASC",
		"post_status" => "publish",
		"posts_per_page" => -1,
		"post__not_in" => array($post->ID)
	);

	remove_all_filters("posts_orderby");

// ***
// Esegui la query
// ***

	$query = new WP_Query($args);

// ***
// Recupera i valori degli eventuali post correlati già registrati
// ***

	$values = get_post_meta( $post->ID, "my-related" );

// ***
// Crea un campo select per ogni $n correlato
// ***

	for ($i = 1; $i <= $n; $i++) {

		if ( $query->have_posts() ) :

			echo "<div style='padding: 10px; border: 1px solid #f5f5f5; margin-bottom: 5px;'>";

			echo "<span style='padding: 5px 10px; background-color: #f5f5f5; margin-right: 20px; -webkit-border-radius: 50px; -moz-border-radius: 50px; border-radius: 50px;'>".$i."</span>";

			echo "<select name='my_field-".$i."' id='my_field-".$i."' class='posts_list'>";

			echo "<option value=''>".esc_html__( "Seleziona un post", "yourdomainname" )."</option>";

			while ($query->have_posts()) : 

				$query->the_post();

				if ( get_the_ID() == $values[0][$i] ) { $selected = "selected"; } else { $selected = ""; }

				echo "<option value=".get_the_ID()." ".$selected.">" . get_the_title() . "</option>";

			endwhile;

			echo "</select>";

			echo "</div>";

		endif;

	}

}

// *********
// Save post
// *********

function my_related_save_postdata( $post_id ) {

	$n = "3";

	for ($i = 1; $i <= $n; $i++) {

		if ( array_key_exists("my_field-".$i, $_POST ) ) {

			$my_related[$i] = intval( $_POST["my_field-".$i] );

			update_post_meta( 
				$post_id,
				"my-related",
				$my_related
			);

		}

	}

}

add_action( "save_post", "my_related_save_postdata" );

// *************
// Add shortcode
// *************

function my_related_shortcode() {

	global $post;

	$meta_value = get_post_meta( $post->ID, "my-related" );

	$post_in = my_related_flatten($meta_value);

	if ($post_in) :

		$args = array( 
			"post_type" => "post", 
			"posts_per_page" => -1, 
			"post__in" => $post_in,
			"orderby" => array("post__in"),
			
		);

		remove_all_filters("posts_orderby");
									
		$loop = new WP_Query( $args );

		if ($loop->found_posts > 0) :

			echo "<h2>".esc_html__("Articoli correlati")."</h2>";

			while ( $loop->have_posts() ) : $loop->the_post();

				get_template_part( "content", get_post_format() );

			endwhile;

		endif;

	endif;	

}

add_shortcode( "my_related", "my_related_shortcode" );

function my_related_flatten($array) { 
	if (!is_array($array)) {
		return FALSE; 
	} 
	$result = array(); 
	foreach ($array as $key => $value) { 
		if (is_array($value)) { 
		  $result = array_merge($result, my_related_flatten($value)); 
		} else { 
		  $result[$key] = $value; 
		} 
	} 
	return $result; 
}